(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var _ = Package.underscore._;
var Random = Package.random.Random;
var Router = Package['iron:router'].Router;
var RouteController = Package['iron:router'].RouteController;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var SandstormEmail = Package['sandstorm-email'].SandstormEmail;
var Accounts = Package['accounts-base'].Accounts;
var check = Package.check.check;
var Match = Package.check.Match;
var SHA256 = Package.sha.SHA256;
var Email = Package.email.Email;
var EmailInternals = Package.email.EmailInternals;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;
var Iron = Package['iron:core'].Iron;

var require = meteorInstall({"node_modules":{"meteor":{"accounts-email-token":{"token_common.js":function(){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/accounts-email-token/token_common.js                                                                 //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
Accounts.emailToken = {};                                                                                        // 1
                                                                                                                 //
Accounts.emailToken._hashToken = function (token) {                                                              // 3
  return {                                                                                                       // 4
    digest: SHA256(token),                                                                                       // 5
    algorithm: "sha-256"                                                                                         // 6
  };                                                                                                             // 4
};                                                                                                               // 8
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"token_server.js":["crypto",function(require){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/accounts-email-token/token_server.js                                                                 //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
var _crypto = require("crypto");                                                                                 // 1
                                                                                                                 //
var _crypto2 = _interopRequireDefault(_crypto);                                                                  //
                                                                                                                 //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                //
                                                                                                                 //
var V1_ROUNDS = 4096; // Selected to take ~5msec at creation time (2016) on a developer's laptop.                // 3
var V1_KEYSIZE = 32; // 256 bits / 8 bits/byte = 32 bytes                                                        // 4
var V1_HASHFUNC = "sha512";                                                                                      // 5
// ^ hash function used with pbkdf2.  Chosen to be different from the function which maps the token              //
// to the value stored in the database.  Note that the first thing that pbkdf2 does is                           //
// HMAC(HASHFUNC, key, salt), and the first thing that HMAC does is either pad or hash the key to                //
// make it the appropriate width.  The result is that knowing sha256(key) and the salt is possibly               //
// sufficient to reconstruct the output of pbkdf2().                                                             //
var V1_CIPHER = "AES-256-CTR"; // cipher used                                                                    // 11
                                                                                                                 //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                        // 13
                                                                                                                 //
var cleanupExpiredTokens = function cleanupExpiredTokens() {                                                     // 15
  Meteor.users.update({                                                                                          // 16
    "services.email.tokens.createdAt": {                                                                         // 17
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                            // 18
    }                                                                                                            // 17
  }, {                                                                                                           // 16
    $pull: {                                                                                                     // 21
      "services.email.tokens": {                                                                                 // 22
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                           // 23
      }                                                                                                          // 22
    }                                                                                                            // 21
  }, {                                                                                                           // 20
    multi: true                                                                                                  // 27
  });                                                                                                            // 26
};                                                                                                               // 29
                                                                                                                 //
Meteor.startup(cleanupExpiredTokens);                                                                            // 31
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                        //
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                          // 33
                                                                                                                 //
var checkToken = function checkToken(tokens, token) {                                                            // 35
  // Looks for an object in `tokens` with `algorithm` and `digest` fields matching those in `token`.             //
  // Returns the matching object, if one is found, or undefined if none match.                                   //
  var foundToken = undefined;                                                                                    // 38
  tokens.forEach(function (userToken) {                                                                          // 39
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                          // 40
      foundToken = userToken;                                                                                    // 42
    }                                                                                                            // 43
  });                                                                                                            // 44
                                                                                                                 //
  return foundToken;                                                                                             // 46
};                                                                                                               // 47
                                                                                                                 //
var consumeToken = function consumeToken(user, token) {                                                          // 49
  var hashedToken = Accounts.emailToken._hashToken(token);                                                       // 50
  var foundToken = checkToken(user.services.email.tokens, hashedToken);                                          // 51
                                                                                                                 //
  if (foundToken !== undefined) {                                                                                // 53
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                 // 54
  }                                                                                                              // 55
                                                                                                                 //
  return foundToken;                                                                                             // 57
};                                                                                                               // 58
                                                                                                                 //
var makeBox = function makeBox(token, plaintext) {                                                               // 60
  // Encrypt plaintext symmetrically with a key derived from token.  Returns an object with                      //
  // ciphertext and associated data needed to decrypt later.                                                     //
                                                                                                                 //
  // Produce a symmetric key.  Note that the token itself does not have sufficient entropy to                    //
  // be used as a key directly, so we need to use a KDF with a strong random salt.                               //
  // In the fullness of time, it might be nice to move away from using a KDF (which blocks the whole             //
  // node process) in favor of the token itself having enough entropy to serve as the key itself.                //
  // This would require lengthening the token, which would make the manual-code-entry workflow                   //
  // worse, so I'm punting on that for now.                                                                      //
  var salt = Random.secret(16);                                                                                  // 70
  var key = _crypto2["default"].pbkdf2Sync(token, salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                     // 71
  var iv = _crypto2["default"].randomBytes(16);                                                                  // 72
  var cipher = _crypto2["default"].createCipheriv(V1_CIPHER, key, iv);                                           // 73
  var ciphertext = cipher.update(new Buffer(plaintext, "binary"));                                               // 74
  return {                                                                                                       // 75
    version: 1,                                                                                                  // 76
    salt: salt,                                                                                                  // 77
    iv: iv.toString("base64"),                                                                                   // 78
    boxedValue: ciphertext.toString("base64")                                                                    // 79
  };                                                                                                             // 75
};                                                                                                               // 81
                                                                                                                 //
var tryUnbox = function tryUnbox(box, secret) {                                                                  // 83
  if (box) {                                                                                                     // 84
    if (box.version === 1) {                                                                                     // 85
      var key = _crypto2["default"].pbkdf2Sync(secret, box.salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);            // 86
      var iv = new Buffer(box.iv, "base64");                                                                     // 87
      var cipher = _crypto2["default"].createDecipheriv(V1_CIPHER, key, iv);                                     // 88
      var cipherText = new Buffer(box.boxedValue, "base64");                                                     // 89
      var plaintext = cipher.update(cipherText);                                                                 // 90
      return plaintext.toString("binary");                                                                       // 91
    }                                                                                                            // 92
  }                                                                                                              // 93
                                                                                                                 //
  // If no box was provided, or it was of an unknown version, return no data.                                    //
  return;                                                                                                        // 96
};                                                                                                               // 97
                                                                                                                 //
// Handler to login with a token.                                                                                //
Accounts.registerLoginHandler("email", function (options) {                                                      // 100
  if (!options.email) {                                                                                          // 101
    return undefined; // don't handle                                                                            // 102
  }                                                                                                              // 103
                                                                                                                 //
  if (!Accounts.identityServices.email.isEnabled()) {                                                            // 105
    throw new Meteor.Error(403, "Email identity service is disabled.");                                          // 106
  }                                                                                                              // 107
                                                                                                                 //
  options = options.email;                                                                                       // 109
  check(options, {                                                                                               // 110
    email: String,                                                                                               // 111
    token: String                                                                                                // 112
  });                                                                                                            // 110
                                                                                                                 //
  var user = Meteor.users.findOne({                                                                              // 115
    "services.email.email": options.email                                                                        // 116
  }, {                                                                                                           // 115
    fields: {                                                                                                    // 118
      "services.email": 1                                                                                        // 119
    }                                                                                                            // 118
  });                                                                                                            // 117
                                                                                                                 //
  if (!user) {                                                                                                   // 123
    console.error("User not found:", options.email);                                                             // 124
    return {                                                                                                     // 125
      error: new Meteor.Error(403, "User not found")                                                             // 126
    };                                                                                                           // 125
  }                                                                                                              // 128
                                                                                                                 //
  if (!user.services.email.tokens) {                                                                             // 130
    console.error("User has no token set:", options.email);                                                      // 131
    return {                                                                                                     // 132
      error: new Meteor.Error(403, "User has no token set")                                                      // 133
    };                                                                                                           // 132
  }                                                                                                              // 135
                                                                                                                 //
  var tokenString = options.token.trim();                                                                        // 137
  var maybeToken = consumeToken(user, tokenString);                                                              // 138
  if (!maybeToken) {                                                                                             // 139
    console.error("Token not found:", options.email);                                                            // 140
    return {                                                                                                     // 141
      error: new Meteor.Error(403, "Invalid authentication code")                                                // 142
    };                                                                                                           // 141
  }                                                                                                              // 144
                                                                                                                 //
  // Attempt to decrypt the resumePath, if provided.                                                             //
  var resumePath = tryUnbox(maybeToken.secureBox, tokenString);                                                  // 147
                                                                                                                 //
  return {                                                                                                       // 149
    userId: user._id,                                                                                            // 150
    options: {                                                                                                   // 151
      resumePath: resumePath                                                                                     // 152
    }                                                                                                            // 151
  };                                                                                                             // 149
});                                                                                                              // 155
                                                                                                                 //
var Url = Npm.require("url");                                                                                    // 157
                                                                                                                 //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                  // 159
var HOSTNAME = ROOT_URL.hostname;                                                                                // 160
                                                                                                                 //
var makeTokenUrl = function makeTokenUrl(email, token, linkingIdentity) {                                        // 162
  if (linkingIdentity) {                                                                                         // 163
    return process.env.ROOT_URL + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId();
  } else {                                                                                                       // 166
    return process.env.ROOT_URL + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);
  }                                                                                                              // 169
};                                                                                                               // 170
                                                                                                                 //
///                                                                                                              //
/// EMAIL VERIFICATION                                                                                           //
///                                                                                                              //
var sendTokenEmail = function sendTokenEmail(db, email, token, linkingIdentity) {                                // 175
  var subject = void 0;                                                                                          // 176
  var text = void 0;                                                                                             // 177
  if (!linkingIdentity) {                                                                                        // 178
    subject = "Log in to " + HOSTNAME;                                                                           // 179
    text = "To confirm this email address on ";                                                                  // 180
  } else {                                                                                                       // 181
    subject = "Confirm this email address on " + HOSTNAME;                                                       // 182
    text = "To confirm this email address on ";                                                                  // 183
  }                                                                                                              // 184
                                                                                                                 //
  text = text + HOSTNAME + ", click on the following link:\n\n" + makeTokenUrl(email, token, linkingIdentity) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                 //
  var options = {                                                                                                // 191
    to: email,                                                                                                   // 192
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                              // 193
    subject: subject,                                                                                            // 194
    text: text                                                                                                   // 195
  };                                                                                                             // 191
                                                                                                                 //
  SandstormEmail.send(options);                                                                                  // 198
};                                                                                                               // 199
                                                                                                                 //
///                                                                                                              //
/// CREATING USERS                                                                                               //
///                                                                                                              //
// returns the user id                                                                                           //
var _createAndEmailTokenForUser = function _createAndEmailTokenForUser(db, email, linkingIdentity, resumePath) {
  check(email, String);                                                                                          // 206
  check(linkingIdentity, Boolean);                                                                               // 207
  check(resumePath, String);                                                                                     // 208
                                                                                                                 //
  var atIndex = email.indexOf("@");                                                                              // 210
  if (atIndex === -1) {                                                                                          // 211
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                          // 212
  }                                                                                                              // 213
                                                                                                                 //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });       // 215
  var userId = void 0;                                                                                           // 217
                                                                                                                 //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                           //
  // Alternately, require using the link over copy/pasting the code, and crank up the entropy.                   //
  var token = Random.id(12);                                                                                     // 221
  var tokenObj = Accounts.emailToken._hashToken(token);                                                          // 222
  tokenObj.createdAt = new Date();                                                                               // 223
  tokenObj.secureBox = makeBox(token, resumePath);                                                               // 224
                                                                                                                 //
  if (user) {                                                                                                    // 226
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                   // 227
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again");
    }                                                                                                            // 231
                                                                                                                 //
    userId = user._id;                                                                                           // 233
                                                                                                                 //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                    // 235
  } else {                                                                                                       // 236
    var options = {};                                                                                            // 237
    user = {                                                                                                     // 238
      services: {                                                                                                // 239
        email: {                                                                                                 // 240
          tokens: [tokenObj],                                                                                    // 241
          email: email                                                                                           // 242
        }                                                                                                        // 240
      }                                                                                                          // 239
    };                                                                                                           // 238
                                                                                                                 //
    userId = Accounts.insertUserDoc(options, user);                                                              // 247
  }                                                                                                              // 248
                                                                                                                 //
  sendTokenEmail(db, email, token, linkingIdentity);                                                             // 250
                                                                                                                 //
  return userId;                                                                                                 // 252
};                                                                                                               // 253
                                                                                                                 //
Meteor.methods({                                                                                                 // 255
  createAndEmailTokenForUser: function createAndEmailTokenForUser(email, linkingIdentity, resumePath) {          // 256
    // method for create user. Requests come from the client.                                                    //
    // This method will create a user if it doesn't exist, otherwise it will generate a token.                   //
    // It will always send an email to the user                                                                  //
                                                                                                                 //
    check(email, String);                                                                                        // 261
    check(linkingIdentity, Boolean);                                                                             // 262
    check(resumePath, String);                                                                                   // 263
                                                                                                                 //
    if (!Accounts.identityServices.email.isEnabled()) {                                                          // 265
      throw new Meteor.Error(403, "Email identity service is disabled.");                                        // 266
    }                                                                                                            // 267
    // Create user. result contains id and token.                                                                //
    var user = _createAndEmailTokenForUser(this.connection.sandstormDb, email, linkingIdentity, resumePath);     // 269
  },                                                                                                             // 270
                                                                                                                 //
  linkEmailIdentityToAccount: function linkEmailIdentityToAccount(email, token) {                                // 272
    // Links the email identity with address `email` and login token `token` to the current account.             //
    check(email, String);                                                                                        // 274
    check(token, String);                                                                                        // 275
    var account = Meteor.user();                                                                                 // 276
    if (!account || !account.loginIdentities) {                                                                  // 277
      throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                 // 278
    }                                                                                                            // 279
                                                                                                                 //
    var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });
    if (!identity) {                                                                                             // 283
      throw new Meteor.Error(403, "Invalid authentication code.");                                               // 284
    }                                                                                                            // 285
                                                                                                                 //
    var maybeToken = consumeToken(identity, token.trim());                                                       // 287
    if (!maybeToken) {                                                                                           // 288
      throw new Meteor.Error(403, "Invalid authentication code.");                                               // 289
    }                                                                                                            // 290
                                                                                                                 //
    Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id);
                                                                                                                 //
    // Return the resume path, if we have one.                                                                   //
    var resumePath = tryUnbox(maybeToken.secureBox, token);                                                      // 296
    return resumePath;                                                                                           // 297
  }                                                                                                              // 298
});                                                                                                              // 255
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/accounts-email-token/token_common.js");
require("./node_modules/meteor/accounts-email-token/token_server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-email-token'] = {};

})();

//# sourceMappingURL=accounts-email-token.js.map
